# Copyright 1999-2003 Gentoo Technologies, Inc.
# Distributed under the terms of the GNU General Public License v2
# $Header: /m/outerspace/share/cvs/otherone/portage/app-portage/rsync-fixes/rsync-fixes-0.2.ebuild,v 1.1 2003/09/21 11:00:20 xkr47 Exp $
# by Jonas Berlin <jberlin@niksula.hut.fi>

DESCRIPTION="A simple program for selecting ~x86 ebuilds you want and x86 ebuilds you don't want"

# Homepage, not used by Portage directly but handy for developer reference
HOMEPAGE="none"

#SRC_URI="ftp://foo.bar.com/${P}.tar.gz"
SRC_URI=""
LICENSE="GPL-2"
SLOT="0"
KEYWORDS="x86"
IUSE=""
DEPEND=""
RDEPEND="dev-lang/perl"

#S=${WORKDIR}/${P}

src_install() {
	dodir /usr/sbin
	dodir /etc/rsync-fixes
#	dodir /etc/rsync-fixes/patches

	cat > ${D}/usr/sbin/rsync-fixes <<'EOF'
#!/usr/bin/perl

my $confdir='/etc/rsync-fixes/';

my $allowfile=$confdir.'allow';
my $denyfile=$confdir.'deny';

#my $patchesdir=$confdir.'patches/';

my $portdir_line=`cat /etc/make.conf|sed 's/#.*//'|grep PORTDIR=|tail -n 1`;
chomp $portdir_line;
$portdir_line =~ s/^\s*PORTDIR=\s*//;
my $portdir = length($portdir_line) ? $portdir_line : '/usr/portage';
$portdir .= '/';

sub parse_file {
    my ($file) = @_;
    return () unless(-f $file);

    my @list;
    open ALLOW, '<'.$file;
    while(<ALLOW>) {
	chomp;
	s/\#.*//;
	s/^\s+//; s/\s+$//;
	next unless(length($_));
	unless(m!^([^/]+)/([^/]+)$!) {
	    print 'Ignoring invalid entry in '.$file.': '.$_."\n";
	    next;
	}
	my ($grp,$pkg) = ($1,$2);
	my $barepkg = $pkg;
	$barepkg =~ s/-[0-9].*//;
	my $path = $portdir.$grp.'/'.$barepkg.'/'.$pkg;
	$path .= '-[0-9]*' if($barepkg eq $pkg);
	$path .= '.ebuild';
	push @list, glob $path;
    }
    return @list;
}

my @allowlist = parse_file($allowfile);
my @denylist = parse_file($denyfile);

sub patch_regexp {
    my ($text,$regexp,@list) = @_;

    for my $file (@list) {
	my $relfile = $file;
	$relfile =~ s/^\Q$portdir\E//;
	$relfile =~ s!/[^/]+/!/!;
	print $text.' '.$relfile.'..';
	
	$file =~ s/\"/\\\"/g;

	system('perl -pe \''.$regexp.'\' < "'.$file.'" > "'.$file.'.new"');
	if(system('diff -q "'.$file.'" "'.$file.'.new" > /dev/null')) {
	    system('cat "'.$file.'.new" > "'.$file.'"');
	    print " \033[32;1mOK\033[m\n";
	} else {
	    print " \033[33;1mno changes\033[m\n";
	}
	system('rm "'.$file.'.new"');
    }
}

patch_regexp "Allowing", 's/^(KEYWORDS.*)~x86/$1x86/', @allowlist;
patch_regexp "Denying", 's/^(KEYWORDS.*[^~])x86/$1~x86/', @denylist;
EOF
	chmod a+rx ${D}/usr/sbin/rsync-fixes

	cat > ${D}/etc/rsync-fixes/allow <<'EOF'
# put your packages to allow here, one per line.
# - currently you can't use patterns like >=media-libs/foo-1.3
# - you can add a * to the end to allow all packages starting with
#   something.
# examples: dev-lang/perl dev-ruby/rdtool-0.6.11*

EOF

	cat > ${D}/etc/rsync-fixes/deny <<'EOF'
# put your packages to deny here, one per line.
# - currently you can't use patterns like >=media-libs/foo-1.3
# - you can add a * to the end to deny all packages starting with
#   something.
# examples: dev-lang/perl dev-ruby/rdtool-0.6.11*

EOF
}
